#include <string>
using namespace std;

template <typename T>
class StackLL {
public:
  StackLL() : _size(0), _head(NULL) {}

  ~StackLL() {
    while (!isEmpty())
      pop();
  }
  
  bool isEmpty() const {
    return _size == 0; // try modify something here,
  }                    // you'll get compile error

  int size() const {
    return _size;
  }
  
  void push(const T& newItem) {
    ListNode* newPtr = new ListNode;
    newPtr->item = newItem;
    newPtr->next = _head;
    _head = newPtr;
    _size++;
  }

  void top(T& stackTop) const {
    if (isEmpty())
      throw string("Stack is empty on top()");
    else {
      stackTop = _head->item;
    } 
  }

  void pop() {
    if (isEmpty())
      throw string("Stack is empty on pop()");
    else {
      ListNode* cur;
      cur = _head;
      _head = _head->next;
      delete cur;
      cur = NULL;
      _size--;
    }
  }

private:
  struct ListNode {
    T item;
    ListNode* next;
  };
  ListNode* _head;
  int _size;
};
